## rpi-sb-provisioner 2.0.4

=== provisioner-service/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.25)

if (CMAKE_BUILD_TYPE STREQUAL "Release")
    include(cmake/DebianHardening.cmake)
    include(cmake/RaspberryPiHardening.cmake)
endif()

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include(FetchContent)

# Prevent installation of Drogon dependencies by setting BUILD_* options before declaring the dependency
set(BUILD_EXAMPLES OFF CACHE BOOL "Build Drogon examples" FORCE)
set(BUILD_CTL ON CACHE BOOL "Build drogon_ctl utility" FORCE)  # Needed for compiling CSP templates
set(BUILD_ORM OFF CACHE BOOL "Build ORM" FORCE)
set(BUILD_BROTLI OFF CACHE BOOL "Build brotli support" FORCE)
set(BUILD_YAML_CONFIG OFF CACHE BOOL "Build yaml config support" FORCE)
# Set this before making Drogon available to ensure it doesn't get installed
set(CMAKE_SKIP_INSTALL_ALL_DEPENDENCY ON CACHE BOOL "Skip installation of all dependencies" FORCE)

FetchContent_Declare(drogon
 GIT_REPOSITORY https://github.com/drogonframework/drogon.git
 GIT_TAG        v1.9.10
 EXCLUDE_FROM_ALL  # Prevents installation in packages
)

# Store original flags
set(ORIGINAL_CXX_FLAGS ${CMAKE_CXX_FLAGS})
# Disable format-nonliteral warning only for Drogon, which is a third party library
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=format-nonliteral")

# Check if population has already been performed
FetchContent_GetProperties(drogon)
string(TOLOWER "drogon" lcName)
if(NOT ${lcName}_POPULATED)
  FetchContent_Populate(drogon)
  add_subdirectory(${${lcName}_SOURCE_DIR} ${${lcName}_BINARY_DIR} EXCLUDE_FROM_ALL)
endif()
# Restore original flags
set(CMAKE_CXX_FLAGS ${ORIGINAL_CXX_FLAGS})

unset(BUILD_YAML_CONFIG)
unset(BUILD_BROTLI)
unset(BUILD_ORM)
unset(BUILD_CTL)
unset(BUILD_EXAMPLES)

# Add libcurl with minimal configuration
set(BUILD_CURL_EXE OFF CACHE BOOL "Set to ON to build curl executable." FORCE)
set(HTTP_ONLY ON CACHE BOOL "Set to ON to build with HTTP support only." FORCE)
set(BUILD_TESTING OFF CACHE BOOL "Set to ON to build libcurl tests." FORCE)
set(ENABLE_MANUAL OFF CACHE BOOL "Set to ON to enable manual." FORCE)
set(CURL_USE_OPENSSL ON CACHE BOOL "Set to ON to use OpenSSL for HTTPS." FORCE)
set(BUILD_SHARED_LIBS OFF CACHE BOOL "Set to OFF to build static libraries." FORCE)
# Disable all protocols except HTTP(S)
set(CURL_DISABLE_DICT ON CACHE BOOL "Set to ON to disable DICT." FORCE)
set(CURL_DISABLE_FILE ON CACHE BOOL "Set to ON to disable FILE." FORCE)
set(CURL_DISABLE_FTP ON CACHE BOOL "Set to ON to disable FTP." FORCE)
set(CURL_DISABLE_GOPHER ON CACHE BOOL "Set to ON to disable GOPHER." FORCE)
set(CURL_DISABLE_IMAP ON CACHE BOOL "Set to ON to disable IMAP." FORCE)
set(CURL_DISABLE_LDAP ON CACHE BOOL "Set to ON to disable LDAP." FORCE)
set(CURL_DISABLE_LDAPS ON CACHE BOOL "Set to ON to disable LDAPS." FORCE)
set(CURL_DISABLE_POP3 ON CACHE BOOL "Set to ON to disable POP3." FORCE)
set(CURL_DISABLE_RTSP ON CACHE BOOL "Set to ON to disable RTSP." FORCE)
set(CURL_DISABLE_SMB ON CACHE BOOL "Set to ON to disable SMB." FORCE)
set(CURL_DISABLE_SMTP ON CACHE BOOL "Set to ON to disable SMTP." FORCE)
set(CURL_DISABLE_TELNET ON CACHE BOOL "Set to ON to disable TELNET." FORCE)
set(CURL_DISABLE_TFTP ON CACHE BOOL "Set to ON to disable TFTP." FORCE)
# Disable libidn2 and libpsl
set(USE_LIBIDN2 OFF CACHE BOOL "Set to OFF to disable libidn2." FORCE)
set(CURL_USE_LIBPSL OFF CACHE BOOL "Set to OFF to disable libpsl." FORCE)
# Disable SSH2
set(CURL_USE_LIBSSH2 OFF CACHE BOOL "Set to OFF to disable libssh2." FORCE)
# Disable additional features
set(CURL_DISABLE_ALTSVC ON CACHE BOOL "Set to ON to disable alt-svc support." FORCE)
set(ENABLE_UNIX_SOCKETS OFF CACHE BOOL "Set to OFF to disable Unix domain sockets." FORCE)
set(CURL_DISABLE_COOKIES ON CACHE BOOL "Set to ON to disable cookies support." FORCE)
set(CURL_DISABLE_HSTS ON CACHE BOOL "Set to ON to disable HSTS support." FORCE)
set(CURL_DISABLE_DOH ON CACHE BOOL "Set to ON to disable DNS-over-HTTPS." FORCE)
set(CURL_DISABLE_WEBSOCKETS ON CACHE BOOL "Set to ON to disable WebSocket." FORCE)
set(CURL_DISABLE_PROXY ON CACHE BOOL "Set to ON to disable proxy support." FORCE)
set(CURL_DISABLE_GETOPTIONS ON CACHE BOOL "Set to ON to disable curl_easy_options API." FORCE)
set(CURL_DISABLE_HEADERS_API ON CACHE BOOL "Set to ON to disable headers-api support." FORCE)
set(CURL_DISABLE_SOCKETPAIR ON CACHE BOOL "Set to ON to disable use of socketpair." FORCE)
# Disable authentication methods (we only need simple HTTPS requests)
# BUG: Authentication provicers are required to build curl, due to a bug in the curl code
set(CURL_DISABLE_BASIC_AUTH ON CACHE BOOL "Set to ON to disable Basic authentication." FORCE)
set(CURL_DISABLE_BEARER_AUTH ON CACHE BOOL "Set to ON to disable Bearer authentication." FORCE)
set(CURL_DISABLE_DIGEST_AUTH ON CACHE BOOL "Set to ON to disable Digest authentication." FORCE)
set(CURL_DISABLE_KERBEROS_AUTH ON CACHE BOOL "Set to ON to disable Kerberos authentication." FORCE)
set(CURL_DISABLE_NEGOTIATE_AUTH ON CACHE BOOL "Set to ON to disable negotiate authentication." FORCE)
set(CURL_DISABLE_AWS ON CACHE BOOL "Set to ON to disable aws-sigv4." FORCE)
set(CURL_DISABLE_NTLM ON CACHE BOOL "Set to ON to disable NTLM support." FORCE)

FetchContent_Declare(curl
 GIT_REPOSITORY https://github.com/curl/curl.git
 GIT_TAG        curl-8_13_0
 PATCH_COMMAND patch -p1 < ${CMAKE_SOURCE_DIR}/cmake/curl/http-no-auth.patch
 UPDATE_DISCONNECTED 1
 EXCLUDE_FROM_ALL  # Prevents installation in packages
)

FetchContent_GetProperties(curl)
string(TOLOWER "curl" curlName)
if(NOT ${curlName}_POPULATED)
  FetchContent_Populate(curl)
  add_subdirectory(${${curlName}_SOURCE_DIR} ${${curlName}_BINARY_DIR} EXCLUDE_FROM_ALL)
endif()

# Unset curl configuration flags
unset(BUILD_CURL_EXE)
unset(HTTP_ONLY)
unset(BUILD_TESTING)
unset(ENABLE_MANUAL)
unset(CURL_USE_OPENSSL)
unset(BUILD_SHARED_LIBS)
unset(CURL_DISABLE_DICT)
unset(CURL_DISABLE_FILE)
unset(CURL_DISABLE_FTP)
unset(CURL_DISABLE_GOPHER)
unset(CURL_DISABLE_IMAP)
unset(CURL_DISABLE_LDAP)
unset(CURL_DISABLE_LDAPS)
unset(CURL_DISABLE_POP3)
unset(CURL_DISABLE_RTSP)
unset(CURL_DISABLE_SMB)
unset(CURL_DISABLE_SMTP)
unset(CURL_DISABLE_TELNET)
unset(CURL_DISABLE_TFTP)
unset(USE_LIBIDN2)
unset(CURL_USE_LIBPSL)
unset(CURL_USE_LIBSSH2)
unset(CURL_DISABLE_ALTSVC)
unset(ENABLE_UNIX_SOCKETS)
unset(CURL_DISABLE_COOKIES)
unset(CURL_DISABLE_HSTS)
unset(CURL_DISABLE_DOH)
unset(CURL_DISABLE_WEBSOCKETS)
unset(CURL_DISABLE_PROXY)
unset(CURL_DISABLE_GETOPTIONS)
unset(CURL_DISABLE_HEADERS_API)
unset(CURL_DISABLE_SOCKETPAIR)
# unset(CURL_DISABLE_BASIC_AUTH)
# unset(CURL_DISABLE_BEARER_AUTH)
# unset(CURL_DISABLE_DIGEST_AUTH)
# unset(CURL_DISABLE_KERBEROS_AUTH)
# unset(CURL_DISABLE_NEGOTIATE_AUTH)
# unset(CURL_DISABLE_AWS)
# unset(CURL_DISABLE_NTLM)

# Download the ZXing library for barcode scanning
set(ZXING_JS_URL "https://cdn.jsdelivr.net/npm/@zxing/library/umd/index.min.js")
set(ZXING_JS_PATH "${CMAKE_SOURCE_DIR}/static/js/zxing.js")

# Add a custom command to download the ZXing library at build time
add_custom_command(
    OUTPUT ${ZXING_JS_PATH}
    COMMAND ${CMAKE_COMMAND} -E echo "Downloading ZXing library from ${ZXING_JS_URL}"
    COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_SOURCE_DIR}/static/js"
    COMMAND curl --silent --show-error --output ${ZXING_JS_PATH} ${ZXING_JS_URL}
    COMMAND ${CMAKE_COMMAND} -E echo "ZXing library downloaded to ${ZXING_JS_PATH}"
    COMMENT "Downloading ZXing barcode scanning library"
    VERBATIM
)

# Create a custom target for downloading ZXing
add_custom_target(download_zxing DEPENDS ${ZXING_JS_PATH})

project(rpi-provisioner-ui)

find_package(SQLite3 REQUIRED)
find_package(jsoncpp REQUIRED)
find_package(PkgConfig REQUIRED)
pkg_check_modules(systemd REQUIRED libsystemd)
find_package(OpenSSL REQUIRED)

# Define the views directory and output directory for compiled templates
set(VIEWS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/views)
set(CSP_OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/views_output)

# Create output directory
file(MAKE_DIRECTORY ${CSP_OUTPUT_DIR})

# Find all .csp files in the views directory
file(GLOB_RECURSE CSP_FILES ${VIEWS_DIR}/*.csp)

# Process each CSP file individually
set(VIEW_SOURCES "")
foreach(cspFile ${CSP_FILES})
  get_filename_component(cspFileName ${cspFile} NAME_WE)
  add_custom_command(
    OUTPUT ${CSP_OUTPUT_DIR}/${cspFileName}.h ${CSP_OUTPUT_DIR}/${cspFileName}.cc
    COMMAND $<TARGET_FILE:drogon_ctl> create view ${cspFile} -o ${CSP_OUTPUT_DIR}
    DEPENDS ${cspFile}
    COMMENT "Compiling CSP template: ${cspFileName}"
    VERBATIM
  )
  list(APPEND VIEW_SOURCES ${CSP_OUTPUT_DIR}/${cspFileName}.cc)
endforeach()

# Create a custom target for CSP compilation
add_custom_target(compile_views DEPENDS ${VIEW_SOURCES})

add_executable(rpi-provisioner-ui)

# Add dependency on the compile_views target
add_dependencies(rpi-provisioner-ui compile_views)

# Add zxing dependency
add_dependencies(rpi-provisioner-ui download_zxing)

target_sources(rpi-provisioner-ui
    PRIVATE
    src/main.cpp
    src/images.cpp
    src/options.cpp
    src/devices.cpp
    src/customisation.cpp
    src/services.cpp
    src/manufacturing.cpp
    src/scantool.cpp
    src/audit.cpp
    src/utils.cpp
    ${VIEW_SOURCES}
)

target_include_directories(rpi-provisioner-ui
    PRIVATE
    src/include
    ${SQLite3_INCLUDE_DIR}
    ${CSP_OUTPUT_DIR}  # Include the compiled templates
    ${curl_SOURCE_DIR}/include  # Add curl headers
)

target_link_libraries(rpi-provisioner-ui
    PRIVATE
    ${jsoncpp_LIBRARY}
    drogon
    ${systemd_LIBRARIES}
    ${SQLite3_LIBRARY}
    libcurl
    OpenSSL::SSL
    OpenSSL::Crypto
)

# Install directives
# Only install our executable and service file, not any of the FetchContent dependencies
install(TARGETS rpi-provisioner-ui
    RUNTIME DESTINATION /usr/bin
)

# Install static files
install(DIRECTORY "${CMAKE_SOURCE_DIR}/static/"
        DESTINATION /usr/share/rpi-sb-provisioner/static
        FILES_MATCHING PATTERN "*.js"
        PERMISSIONS OWNER_READ GROUP_READ WORLD_READ)

=== debian/changelog ===
rpi-sb-provisioner (2.0.4) unstable; urgency=medium

  * packaging: Enforce modern (>= 28.2) rpi-eeprom dependency to fix nvme boot
    issues
  * manufacturing: Fix crash when provisioning NVMe devices
  * WebUI: Fix navigation bar disruption when updates are available

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Tue, 10 Jun 2025 14:00:00 +0100

rpi-sb-provisioner (2.0.3) unstable; urgency=medium

  * packaging: Enforce modern (>= 20250519~100421) rpiboot dependency
  * packaging: Enforce modern (>= 27.10) rpi-eeprom dependency
  * packaging: Update Standards-Version to 4.7.2
  * provisioner: Fixup 2712 re-provisioning

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Wed, 28 May 2025 17:00:00 +0100

rpi-sb-provisioner (2.0.2) unstable; urgency=medium

  * WebUI: Don't hide CUSTOMER_KEY_FILE_PEM in options
  * WebUI: Introduce naked provisioning customisation hook
  * WebUI: Customsiation: Fix script name handling

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Mon, 12 May 2025 17:00:00 +0100

rpi-sb-provisioner (2.0.1) unstable; urgency=medium

  * provisioner: Fixup xxd dependency
  * provisioner: Fixup ethernet handling
  * readme: Remove manual cache clearing instructions
  * WebUI: Add manufacturing database API

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Thu, 08 May 2025 11:59:55 +0000

rpi-sb-provisioner (2.0.0) unstable; urgency=medium

  * Architecture and Core Changes:
    - Split pre-and-post-Fastboot phases for better reliability
    - Add support for multiple Fastboot devices with improved
      device tracking
    - Add support for state tracking database with SQLite
    - Add WebUI for provisioning management and monitoring
    - Remove TUI (Python-based) provisioning interface

  * Provisioning Modes and Device Support:
    - Introduce FDE-Only, Naked and Secure-Boot provisioning modes
    - Add support for Zero 2W (2710) devices
    - Improve JTAG lock configuration

  * Performance Improvements:
    - Implement ethernet data transfer when available for faster
      provisioning
    - Use sparse boot images for improved performance
    - Restructure environment setup and cleanup processes
    - Enhance timeout handling with reduced fatal timeouts

  * Security and Reliability:
    - Add branch protection and other hardening measures
    - Enhance error management and logging across all provisioners
    - Add manufacturing database integration and device metadata
      collection
    - Remove DEMO_MODE from all components
    - Switch from system curl to minimal embedded curl library
    - Reduce attack surface by disabling unneeded curl features

  * UI and Configuration:
    - Add customisation scripts to the WebUI
    - Add version check and GitHub link in WebUI
    - Add Debian hardening options and build improvements
    - Removed RPI_DEVICE_FETCH_METADATA, we now always fetch metadata

  * System Integration:
    - Add systemd service integration
    - Fix lintian warnings and implement proper systemd service
      handling
    - Increase specificity in device handling and ignore rpiboot 
      mass-storage endpoint
    - Add lintian override for embedded curl library

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Mon, 14 Apr 2025 11:59:55 +0000

rpi-sb-provisioner (1.3.7) unstable; urgency=medium

  * provisioner: Clean up ephemeral RPI_SB_WORKDIRs

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Wed, 12 Feb 2025 15:20:00 +0000

rpi-sb-provisioner (1.3.6) unstable; urgency=medium

  * provisioner: Always sparse the rootfs for improved transfer speeds

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Wed, 12 Feb 2025 15:15:00 +0000

rpi-sb-provisioner (1.3.5) unstable; urgency=medium

  * provisioner: Fixup ethernet handling
  * provisioner: Move device keypair retreival to earlier phase
  * provisioner: Fix up 64-bit serial handling
  * provisioner: Fix up multi-device provisioning

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Wed, 12 Feb 2025 14:15:00 +0000

rpi-sb-provisioner (1.3.4) unstable; urgency=medium

  * provisioner: Use rpi-make-boot-image for better updates
  * provisioner: Add initial support for ethernet data plane transfer
  * packaging: Ignore .git directory for source tarball creation
  * packaging: Fixup manpage generation

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Mon, 10 Feb 2025 16:15:00 +0000

rpi-sb-provisioner (1.3.3) unstable; urgency=medium

  * provisioner: Remove unsafe automatic pre-signd device retry behaviour
  * provisioner: Add special-skip-keywriter file check to handle pre-signed
      devices
  * packaging: Add autogenerated manpage
  * packaging: Fix up Homepage item in control file

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Wed, 05 Feb 2025 16:45:00 +0000

rpi-sb-provisioner (1.3.2) unstable; urgency=critical

  * provisioner: Update cryptroot to address GHSA-pwq3-7gpg-qpcj
  * provisioner: Attempt automatic pre-signed device recovery on
      Rapsberry Pi 5-family devices
  * provisioner: Use rpi-eeprom-update logic to find source eeprom image

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Mon, 03 Feb 2025 12:15:00 +0000

rpi-sb-provisioner (1.3.1) unstable; urgency=medium

  * provisioner: Generate depmod information for pre-boot
      authentication environment
  * provisioner: Introduce LUKSv2 cipher selection mechanism
  * provisioner: Device-unique key retreival fixes

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Fri, 13 Dec 2024 11:15:00 +0000

rpi-sb-provisioner (1.3.0) unstable; urgency=medium

  * provisioner: Add optional manufacturing database
  * provisioner: Add optional device keypair archiving

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Thu, 21 Nov 2024 13:57:00 +0000

rpi-sb-provisioner (1.2.1) unstable; urgency=medium

  * provisioner: Remove extraneous disk-id argument

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Thu, 10 Oct 2024 13:57:00 +0000

rpi-sb-provisioner (1.2.0) unstable; urgency=medium

  * monitor: Rework finding completed & failed devices
  * monitor: Make in-progress devices selectable


=== debian/control ===
Source: rpi-sb-provisioner
Section: admin
Priority: optional
Maintainer: Tom Dewey <tom.dewey@raspberrypi.com>
Build-Depends: debhelper (>= 13), cmake (>= 3.25), g++ (>= 10), libsqlite3-dev, libjsoncpp-dev, libsystemd-dev, pandoc, asciidoctor, uuid-dev, libssl-dev
Standards-Version: 4.7.2
Homepage: https://www.raspberrypi.com/software

Package: rpi-sb-provisioner
Architecture: arm64
Pre-Depends: dpkg (>= 1.16.1), ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}, fastboot (>= 33.0.3), python3, python3-pycryptodome, openssl, cpio, android-sdk-platform-tools, rpi-eeprom (>= 28.2), rpiboot (>= 20250519~100421), curl, dctrl-tools, diffutils, libengine-pkcs11-openssl, libp11-kit-dev, gnutls-bin, jq, sqlite3, iputils-ping, rpi-make-boot-image, android-sdk-libsparse-utils, libjsoncpp25, libsystemd0, xxd
Description: Automated provisioning of secure boot for Raspberry Pi Devices
 This package provides tools for configuring and provisioning Raspberry Pi
 devices with secure boot capabilities. It enables automated setup of
 security features including secure boot chains, firmware verification,
 and hardware-backed security mechanisms on supported Raspberry Pi models.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1

# Enable all hardening options available in Debian
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Allow network access during the build
export DEB_BUILD_NETWORK = yes

# Target to generate the man page
debian/rpi-sb-provisioner.1:
	# First create the content from the README
	asciidoctor -b docbook --attribute leveloffset=+1 --out-file - README.adoc |\
	  pandoc -f docbook -s -t man --shift-heading-level-by=-1 > debian/rpi-sb-provisioner.1.tmp
	  
	# Now add proper NAME section with awk and create final man page
	awk 'BEGIN { print ".TH \"rpi-sb-provisioner\" \"1\" \"\" \"\" \"User Commands\""; \
	             print ".SH NAME"; \
	             print "rpi-sb-provisioner \\- Raspberry Pi Secure Boot Provisioner"; \
	             first_section = 1; } \
	     /^\.SH / { if (first_section) { first_section = 0; } else { print; } next; } \
	     /^\.TH / { next; } \
	     /^\.hy/ { next; } \
	     { if (!first_section) print; }' debian/rpi-sb-provisioner.1.tmp > debian/rpi-sb-provisioner.1
	     
	# Clean up temporary file
	rm -f debian/rpi-sb-provisioner.1.tmp

%:
	# Generate the man page before running dh
	$(MAKE) -f debian/rules debian/rpi-sb-provisioner.1
	dh $@

# Configure the CMake project with network fetch enabled
override_dh_auto_configure:
	dh_auto_configure --sourcedirectory=provisioner-service -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DFETCHCONTENT_QUIET=OFF

# Build the CMake project
override_dh_auto_build:
	dh_auto_build --sourcedirectory=provisioner-service

# Install the CMake project but exclude drogon tools
override_dh_auto_install:
	dh_auto_install --sourcedirectory=provisioner-service

# Enable and start the UI service by default
override_dh_installsystemd:
	dh_installsystemd --restart-after-upgrade --name=rpi-provisioner-ui
	dh_installsystemd --name=rpi-sb-provisioner@
	dh_installsystemd --name=rpi-fde-provisioner@
	dh_installsystemd --name=rpi-naked-provisioner@
	dh_installsystemd --name=rpi-sb-bootstrap@
	dh_installsystemd --name=rpi-sb-triage@
	dh_installsystemd --no-enable --name=fetch-repo-package-list@
	dh_installsystemd --no-enable --name=rpi-package-download@

## rpi-sb-provisioner 2.1.3

=== provisioner-service/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,41 @@
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 include(FetchContent)
+
+# Add jsoncpp FIRST (before Drogon) so Drogon finds and uses this vendored version
+# instead of finding system libjsoncpp-dev
+set(BUILD_SHARED_LIBS OFF CACHE BOOL "Build shared libraries" FORCE)
+set(BUILD_STATIC_LIBS ON CACHE BOOL "Build static libraries" FORCE)
+set(JSONCPP_WITH_TESTS OFF CACHE BOOL "Compile and run JsonCpp test executables" FORCE)
+set(JSONCPP_WITH_POST_BUILD_UNITTEST OFF CACHE BOOL "Automatically run unit-tests as a post build step" FORCE)
+set(JSONCPP_WITH_PKGCONFIG_SUPPORT OFF CACHE BOOL "Generate and install .pc files" FORCE)
+set(JSONCPP_WITH_CMAKE_PACKAGE OFF CACHE BOOL "Generate and install cmake package files" FORCE)
+
+FetchContent_Declare(jsoncpp
+ GIT_REPOSITORY https://github.com/open-source-parsers/jsoncpp.git
+ GIT_TAG        1.9.6
+ EXCLUDE_FROM_ALL  # Prevents installation in packages
+)
+
+FetchContent_GetProperties(jsoncpp)
+string(TOLOWER "jsoncpp" jsoncppName)
+if(NOT ${jsoncppName}_POPULATED)
+  FetchContent_Populate(jsoncpp)
+  add_subdirectory(${${jsoncppName}_SOURCE_DIR} ${${jsoncppName}_BINARY_DIR} EXCLUDE_FROM_ALL)
+endif()
+
+# Set JSONCPP_INCLUDE_DIRS and JSONCPP_LIBRARIES so Drogon's find_package(Jsoncpp) succeeds
+# These variables are what FindJsoncpp.cmake looks for, and must be set before Drogon configures
+set(JSONCPP_INCLUDE_DIRS "${${jsoncppName}_SOURCE_DIR}/include" CACHE PATH "jsoncpp include dir" FORCE)
+set(JSONCPP_LIBRARIES jsoncpp_static CACHE STRING "jsoncpp library" FORCE)
+
+# Unset jsoncpp configuration flags
+unset(BUILD_SHARED_LIBS)
+unset(BUILD_STATIC_LIBS)
+unset(JSONCPP_WITH_TESTS)
+unset(JSONCPP_WITH_POST_BUILD_UNITTEST)
+unset(JSONCPP_WITH_PKGCONFIG_SUPPORT)
+unset(JSONCPP_WITH_CMAKE_PACKAGE)
 
 # Prevent installation of Drogon dependencies by setting BUILD_* options before declaring the dependency
 set(BUILD_EXAMPLES OFF CACHE BOOL "Build Drogon examples" FORCE)
@@ -21,7 +56,7 @@
 
 FetchContent_Declare(drogon
  GIT_REPOSITORY https://github.com/drogonframework/drogon.git
- GIT_TAG        v1.9.10
+ GIT_TAG        v1.9.11
  EXCLUDE_FROM_ALL  # Prevents installation in packages
 )
 
@@ -95,7 +130,7 @@
 
 FetchContent_Declare(curl
  GIT_REPOSITORY https://github.com/curl/curl.git
- GIT_TAG        curl-8_13_0
+ GIT_TAG        curl-8_16_0
  PATCH_COMMAND patch -p1 < ${CMAKE_SOURCE_DIR}/cmake/curl/http-no-auth.patch
  UPDATE_DISCONNECTED 1
  EXCLUDE_FROM_ALL  # Prevents installation in packages
@@ -167,10 +202,27 @@
 # Create a custom target for downloading ZXing
 add_custom_target(download_zxing DEPENDS ${ZXING_JS_PATH})
 
+# Download D3.js library for graph visualization
+set(D3_JS_URL "https://cdn.jsdelivr.net/npm/d3@7.9.0/dist/d3.min.js")
+set(D3_JS_PATH "${CMAKE_SOURCE_DIR}/static/js/d3.min.js")
+
+# Add a custom command to download D3.js at build time
+add_custom_command(
+    OUTPUT ${D3_JS_PATH}
+    COMMAND ${CMAKE_COMMAND} -E echo "Downloading D3.js library from ${D3_JS_URL}"
+    COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_SOURCE_DIR}/static/js"
+    COMMAND curl --silent --show-error --output ${D3_JS_PATH} ${D3_JS_URL}
+    COMMAND ${CMAKE_COMMAND} -E echo "D3.js library downloaded to ${D3_JS_PATH}"
+    COMMENT "Downloading D3.js visualization library"
+    VERBATIM
+)
+
+# Create a custom target for downloading D3.js
+add_custom_target(download_d3 DEPENDS ${D3_JS_PATH})
+
 project(rpi-provisioner-ui)
 
 find_package(SQLite3 REQUIRED)
-find_package(jsoncpp REQUIRED)
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(systemd REQUIRED libsystemd)
 find_package(OpenSSL REQUIRED)
@@ -210,6 +262,9 @@
 # Add zxing dependency
 add_dependencies(rpi-provisioner-ui download_zxing)
 
+# Add D3.js dependency
+add_dependencies(rpi-provisioner-ui download_d3)
+
 target_sources(rpi-provisioner-ui
     PRIVATE
     src/main.cpp
@@ -235,23 +290,6 @@
 
 target_link_libraries(rpi-provisioner-ui
     PRIVATE
-    ${jsoncpp_LIBRARY}
+    jsoncpp_static
     drogon
     ${systemd_LIBRARIES}
-    ${SQLite3_LIBRARY}
-    libcurl
-    OpenSSL::SSL
-    OpenSSL::Crypto
-)
-
-# Install directives
-# Only install our executable and service file, not any of the FetchContent dependencies
-install(TARGETS rpi-provisioner-ui
-    RUNTIME DESTINATION /usr/bin
-)
-
-# Install static files
-install(DIRECTORY "${CMAKE_SOURCE_DIR}/static/"
-        DESTINATION /usr/share/rpi-sb-provisioner/static
-        FILES_MATCHING PATTERN "*.js"
-        PERMISSIONS OWNER_READ GROUP_READ WORLD_READ)

=== debian/changelog ===
rpi-sb-provisioner (2.1.3) unstable; urgency=medium

  * Features:
    - Add test mode for USB device topology simulation
    - Add timestamp handling and formatting for service logs
    - Integrate D3.js for enhanced graph visualization in device topology UI
    - Enhance collision resolution for device layout in UI
    - Add configuration field validation endpoint with real-time UI feedback
    - Add Nginx reverse proxy example configuration with PAM authentication

  * Bootstrap Improvements:
    - Run metadata_gather before post-flash for better data collection
    - Simplify IPv6 address extraction with awk

  * WebUI:
    - Allow boot package generation for both secure-boot and fde-only
      provisioning styles
    - Display last updated timestamps for services in user-friendly format
    - Improve device visualization with D3.js graph rendering and tooltips

  * Manufacturing Data:
    - Add support for capturing Zero W and unknown device values

  * Packaging:
    - Update to debhelper-compat version 13
    - Use jsoncpp as a vendored dependency in CMake configuration
    - Update static files path configuration for improved clarity
    - Update lintian overrides for embedded libjsoncpp

  * Dependencies:
    - Update rpiboot and rpi-eeprom to catch November 2025 firmware

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Thu, 16 Jan 2026 12:00:00 +0000

rpi-sb-provisioner (2.1.2) unstable; urgency=medium

  * Bootstrap: Fix USB path extraction for hub-connected devices
  * WebUI: Add serial-based fallback matching for device status display
  * WebUI: Add dynamic validation for options form fields
  * Fix: Devices connected via USB hubs now correctly show provisioning
    status in the topology map view
  * WebUI: Fixup device state retrieval race condition
  * Packaging:
    - Fix maintainer-script-ignores-errors by adding set -e to postinst
    - Fix man page table formatting by preprocessing with tbl
    - Add lintian override for boot image generator

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Mon, 17 Nov 2025 16:45:00 +0100

rpi-sb-provisioner (2.1.1) unstable; urgency=medium

  * WebUI: Fix bootimg generator bashisms
  * WebUI: Style bootimg generator buttons
  * WebUI: Add explicit bootimg generation button
  * WebUI: Fix hangs on navigation on pages using AJAX

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Fri, 10 Oct 2025 16:45:00 +0100

rpi-sb-provisioner (2.1.0) unstable; urgency=medium

  * Features:
    - Add automatic boot image generator for creating signed boot.img
      from uploaded OS images
    - Add Debian package generation for boot image updates
    - Add RPI_SB_PROVISIONER_ENABLE_PRIVATE_KEY_API security option
    - Add pagination and ordering for service log API

  * Documentation:
    - Complete README rewrite with beginner-friendly content
    - Add architecture documentation with workflow diagrams
    - Add boot image generator documentation
    - Add Debian package creation examples
    - Enhance API documentation with more examples

  * Bootstrap Improvements:
    - Fixup EEPROM update for naked provisioning on 2711/2712
    - Remove unnecessary writeSig() function, use rpi-eeprom-digest
    - Improve handling of special re-provisioning cases for Pi 5
    - Add better logging for edge cases (empty serials, missing firmware)
    - Improve non-secure-boot EEPROM update flow

  * WebUI:
    - Add new device status UI based on USB topology
    - Enhance audit logging across all endpoints

  * Script Improvements:
    - Strip GNU-specific and Bash-specific syntax for POSIX compliance
    - Fix shell option detection in customization scripts
    - Fix regex in simg_expanded_size() function
    - Fix depmod handling for kernel modules

  * Manufacturing Database:
    - Fixup metadata collection (secure vs signed distinction)
    - Improve accuracy of device state tracking

  * Packaging:
    - Update rpiboot dependency to >= 20251002~150524
    - Update rpi-eeprom dependency to >= 28.5
    - Update embedded curl to 8.16.0

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Fri, 10 Oct 2025 16:45:00 +0100

rpi-sb-provisioner (2.0.7) unstable; urgency=medium

  * WebUI: Expand manufacturing DB API, table

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Thu, 21 Aug 2025 16:30:00 +0100

rpi-sb-provisioner (2.0.6) unstable; urgency=medium

  * WebUI: Fixup SHA256 calculation cancellation
  * naked: Fixup bootloader configuation file default
  * all: Fixed up post-flash customisation script arguments
  * naked: Fix up TCP connection set-up
  * bootstrap: Drop non-secure-boot EEPROM handling

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Wed, 16 Jul 2025 16:30:00 +0100

rpi-sb-provisioner (2.0.5) unstable; urgency=medium

  * WebUI: Add audit logging to images API
  * WebUI: Add firmware selection UI
  * WebUI: Asynchronous services loading
  * WebUI: Add SHA256 cancellation when images are deleted
  * WebUI: Fix CORS issues with WebUI
  * provisioner: Fix 2711 Fastboot utility OS signing

 -- Tom Dewey <tom.dewey@raspberrypi.com>  Tue, 24 Jun 2025 16:30:00 +0100

=== debian/control ===
Source: rpi-sb-provisioner
Section: admin
Priority: optional
Maintainer: Tom Dewey <tom.dewey@raspberrypi.com>
Build-Depends: debhelper-compat (= 13), cmake (>= 3.25), g++ (>= 10), libsqlite3-dev, libsystemd-dev, pandoc, asciidoctor, uuid-dev, libssl-dev
Standards-Version: 4.7.2
Homepage: https://www.raspberrypi.com/software

Package: rpi-sb-provisioner
Architecture: arm64
Pre-Depends: dpkg (>= 1.16.1), ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}, fastboot (>= 33.0.3), python3, python3-pycryptodome, openssl, cpio, android-sdk-platform-tools, rpi-eeprom (>= 28.8-1), rpiboot (>= 20251107~092017), curl, dctrl-tools, diffutils, libengine-pkcs11-openssl, libp11-kit-dev, gnutls-bin, jq, sqlite3, iputils-ping, rpi-make-boot-image, android-sdk-libsparse-utils, libsystemd0, xxd
Description: Automated provisioning of secure boot for Raspberry Pi Devices
 This package provides tools for configuring and provisioning Raspberry Pi
 devices with secure boot capabilities. It enables automated setup of
 security features including secure boot chains, firmware verification,
 and hardware-backed security mechanisms on supported Raspberry Pi models.

=== debian/rules ===
--- 
+++ 
@@ -14,7 +14,7 @@
 	asciidoctor -b docbook --attribute leveloffset=+1 --out-file - README.adoc |\
 	  pandoc -f docbook -s -t man --shift-heading-level-by=-1 > debian/rpi-sb-provisioner.1.tmp
 	  
-	# Now add proper NAME section with awk and create final man page
+	# Now add proper NAME section with awk and create intermediate man page
 	awk 'BEGIN { print ".TH \"rpi-sb-provisioner\" \"1\" \"\" \"\" \"User Commands\""; \
 	             print ".SH NAME"; \
 	             print "rpi-sb-provisioner \\- Raspberry Pi Secure Boot Provisioner"; \
@@ -22,10 +22,13 @@
 	     /^\.SH / { if (first_section) { first_section = 0; } else { print; } next; } \
 	     /^\.TH / { next; } \
 	     /^\.hy/ { next; } \
-	     { if (!first_section) print; }' debian/rpi-sb-provisioner.1.tmp > debian/rpi-sb-provisioner.1
+	     { if (!first_section) print; }' debian/rpi-sb-provisioner.1.tmp > debian/rpi-sb-provisioner.1.raw
+	
+	# Preprocess with tbl to resolve table formatting
+	tbl debian/rpi-sb-provisioner.1.raw > debian/rpi-sb-provisioner.1
 	     
-	# Clean up temporary file
-	rm -f debian/rpi-sb-provisioner.1.tmp
+	# Clean up temporary files
+	rm -f debian/rpi-sb-provisioner.1.tmp debian/rpi-sb-provisioner.1.raw
 
 %:
 	# Generate the man page before running dh
@@ -55,5 +58,6 @@
 	dh_installsystemd --name=rpi-naked-provisioner@
 	dh_installsystemd --name=rpi-sb-bootstrap@
 	dh_installsystemd --name=rpi-sb-triage@
+	dh_installsystemd --no-enable --name=rpi-sb-image-bootimg-generator@
 	dh_installsystemd --no-enable --name=fetch-repo-package-list@
 	dh_installsystemd --no-enable --name=rpi-package-download@
